//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "FlatEdit.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
// ValidCtrCheck is used to assure that the components created do not have
// any pure virtual functions.
//

static inline void ValidCtrCheck(TFlatEdit *)
{
new TFlatEdit(NULL);
}
//---------------------------------------------------------------------------
__fastcall TFlatEdit::TFlatEdit(TComponent* Owner)
: TEdit(Owner)
{
  FMouseInControl = false;
}
//---------------------------------------------------------------------------
void __fastcall TFlatEdit::WMNCPaint(TWMNCPaint &Message)
{
  if (FMouseInControl) TEdit::Dispatch(&Message);
  else {
    HDC DC;
    TRect R;

    DC = GetWindowDC(Handle);
    GetWindowRect(Handle, &R);
    OffsetRect(&R, -R.left, -R.top);
    FillRect(DC, &R, (HBRUSH)(COLOR_WINDOW + 1));
    ReleaseDC(Handle, DC);
  }
}
//---------------------------------------------------------------------------
void __fastcall TFlatEdit::CMMouseEnter(TMessage &Message)
{
  TEdit::Dispatch(&Message);

  FMouseInControl = true;

  RedrawWindow(Handle, NULL, NULL,RDW_FRAME	| RDW_INVALIDATE |RDW_UPDATENOW);
}
//---------------------------------------------------------------------------
void __fastcall TFlatEdit::CMMouseLeave(TMessage &Message)
{
  TEdit::Dispatch(&Message);

  FMouseInControl = false;

  RedrawWindow(Handle, NULL, NULL,RDW_FRAME	| RDW_INVALIDATE |RDW_UPDATENOW);
}
//---------------------------------------------------------------------------
namespace Flatedit
{
void __fastcall PACKAGE Register()
{
  TComponentClass classes[1] = {__classid(TFlatEdit)};
  RegisterComponents("Lecture", classes, 0);
}
}
//---------------------------------------------------------------------------
 