//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include <ctype.h>

#include "GradientEdit.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
// ValidCtrCheck is used to assure that the components created do not have
// any pure virtual functions.
//

static inline void ValidCtrCheck(TGradientEdit *)
{
new TGradientEdit(NULL);
}
//---------------------------------------------------------------------------
__fastcall TGradientEdit::TGradientEdit(TComponent* Owner)
: TCustomControl(Owner)
{
  Width = 200;
  Height = 28;
}
//---------------------------------------------------------------------------
void __fastcall TGradientEdit::SetText(AnsiString &Value)
{
  if (FText != Value) {
    FText = Value;
    Invalidate();
  }
}
//---------------------------------------------------------------------------
void __fastcall TGradientEdit::Paint(void)
{
  TCustomControl::Paint();

  COLORREF cFrom = ColorToRGB(FFromColor), cTo = ColorToRGB(FToColor);
  int r1 = GetRValue(cFrom), g1 = GetGValue(cFrom), b1 = GetBValue(cFrom);
  int r2 = GetRValue(cTo), g2 = GetGValue(cTo), b2 = GetBValue(cTo);
  int n = FText.Length();

  if (n == 0) return;

  float r_inc = (r2 - r1) / n, g_inc = (g2 - g1) / n, b_inc = (b2 - b1) / n;

  Canvas->Brush->Color = clWindow;
  Canvas->FillRect(Canvas->ClipRect);

  Canvas->Font = Font;

  int left = 0;
  for (int i = 0; i < n; i++) {
    Canvas->Font->Color = RGB(r1, g1, b1);

    AnsiString S = FText.SubString(i + 1, 1);

    Canvas->TextOut(left, 2, S);
    left += Canvas->TextWidth(S);

    r1 += r_inc;
    g1 += g_inc;
    b1 += b_inc;
  }
}
//---------------------------------------------------------------------------
void __fastcall TGradientEdit::SetColors(int index, TColor Value)
{
  switch (index) {
    case 0: if (FFromColor != Value) {
              FFromColor = Value;
              Invalidate();
            }
            break;

    case 1: if (FToColor != Value) {
              FToColor = Value;
              Invalidate();
            }
            break;
  }
}
//---------------------------------------------------------------------------
void __fastcall TGradientEdit::KeyPress(char &Key)
{
  TCustomControl::KeyPress(Key);

  if (isprint(Key))
    Text = Text + Key;
  else if (Key == '\b')
    Text = Text.SubString(1, Text.Length() - 1); 
}
//---------------------------------------------------------------------------
void __fastcall TGradientEdit::WMLButtonDown(TWMLButtonDown &Message)
{
  TCustomControl::Dispatch(&Message);

  if (ComponentState.Contains(csDesigning)) return;

  if (!Focused()) SetFocus();
}
//---------------------------------------------------------------------------
namespace Gradientedit
{
void __fastcall PACKAGE Register()
{
  TComponentClass classes[1] = {__classid(TGradientEdit)};
  RegisterComponents("Lecture", classes, 0);
}
}
//---------------------------------------------------------------------------
