//---------------------------------------------------------------------------
#ifndef GradientEditH
#define GradientEditH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
//---------------------------------------------------------------------------
class PACKAGE TGradientEdit : public TCustomControl
{
private:
  TColor FFromColor, FToColor;
  AnsiString FText;

  void __fastcall SetText(AnsiString &Value);
  void __fastcall SetColors(int index, TColor Value);

  virtual void __fastcall Paint(void);
  DYNAMIC void __fastcall KeyPress(char &Key);

  void __fastcall WMLButtonDown(TWMLButtonDown &Message);
protected:
public:
__fastcall TGradientEdit(TComponent* Owner);
__published:
  __property TColor FromColor = {read=FFromColor, write=SetColors, index=0};
  __property TColor ToColor = {read=FToColor, write=SetColors, index=1};

  __property AnsiString Text = {read=FText, write=SetText};

  __property Align;
  __property Color;
  __property Ctl3D;
  __property Enabled;
  __property Font;
  __property ParentColor;
  __property ParentCtl3D;
  __property ParentFont;
  __property ParentShowHint;
  __property ShowHint;
  __property TabOrder;
  __property TabStop;
  __property PopupMenu;
  __property Visible;


  __property OnClick;
  __property OnDblClick;
  __property OnDragDrop;
  __property OnDragOver;
  __property OnEndDrag;
  __property OnEnter;
  __property OnExit;
  __property OnKeyDown;
  __property OnKeyPress;
  __property OnKeyUp;
  __property OnMouseDown;
  __property OnMouseMove;
  __property OnMouseUp;
  __property OnStartDrag;

  BEGIN_MESSAGE_MAP
    VCL_MESSAGE_HANDLER(WM_LBUTTONDOWN, TWMLButtonDown, WMLButtonDown);
  END_MESSAGE_MAP(TCustomControl);
};
//---------------------------------------------------------------------------
#endif
