//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Ruler.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
// ValidCtrCheck is used to assure that the components created do not have
// any pure virtual functions.
//

static inline void ValidCtrCheck(TRuler *)
{
new TRuler(NULL);
}
//---------------------------------------------------------------------------
__fastcall TRuler::TRuler(TComponent* Owner)
: TGraphicControl(Owner)
{
  Width = 300;
  Height = 40;
}
//---------------------------------------------------------------------------
void __fastcall TRuler::Paint(void)
{
  TGraphicControl::Paint();

  Canvas->Brush->Color = clWhite;
  Canvas->FillRect(Canvas->ClipRect);

  int PixelsPerCM = Screen->PixelsPerInch / 2.54;
  int Ticks = ClientWidth / PixelsPerCM;

  for (int i = 0; i <= Ticks; i++) {
    Canvas->MoveTo(i * PixelsPerCM, 0);
    Canvas->LineTo(i * PixelsPerCM, i % 5 ? ClientHeight / 4 : ClientHeight / 2);

    AnsiString S = IntToStr(i);
    Canvas->TextOut(i * PixelsPerCM - Canvas->TextWidth(S) / 2, ClientHeight - 15, S);
  }
}
//---------------------------------------------------------------------------
namespace Ruler
{
void __fastcall PACKAGE Register()
{
  TComponentClass classes[1] = {__classid(TRuler)};
  RegisterComponents("Lecture", classes, 0);
}
}
//---------------------------------------------------------------------------
 